#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "warpi.h"
#include "wvarpi.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    //
    widht = ui->gView->width();
    height = ui->gView->height();
    //
    rszx    = 640;
    rszy    = 480;
    //
    scene               = new QGraphicsScene();
    pix                 = new QPixmap(widht,height);
    paint               = new QPainter(pix);
    paint->setWindow(0,0,rszx,rszy);
    int  cnt1, cnt2;
    //
    //
    ui->gView->setScene(scene);
    scene->addPixmap(*pix);
    //
    cnt1 = 0;
    while(cnt1 < rszy)
    {
        cnt2 = 0;
        while(cnt2 < rszx)
        {
            dpix[cnt2][cnt1] = 0;
            cnt2++;
        }
        cnt1++;
    }
    //
    valm1       = 0;
    valm2       = 0;
    valm3       = 0;
    valm4       = 0;
    wrvalm1     = 0;
    wrvalm2     = 0;
    wrvalm3     = 0;
    wrvalm4     = 0;
    wrhcam      = 0;
    wrvcam      = 0;
    hcam        = 0;
    vcam        = 0;
    hcamold     = 0;
    vcamold     = 0;
    connected   =   false;
    vconnected  =   false;
    infmode     =   1;
    cmd         = _cmd_stop;
    //
    ui->strIP->setText(_def_ip);
    ui->strPort->setText("8971");
    ui->vstrIP->setText(_def_ip);
    ui->vstrPort->setText("8998");
    //
    //fdraw();
    //
    tmr = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr->setInterval(500); // Задаем интервал таймера
    connect(tmr, SIGNAL(timeout()), this, SLOT(Vals())); // Подключаем сигнал таймера к нашему слоту
    tmr->start(0); // Запускаем таймер
    tmr2 = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr2->setInterval(5000); // Задаем интервал таймера
    connect(tmr2, SIGNAL(timeout()), this, SLOT(TimerInfo())); // Подключаем сигнал таймера к нашему слоту
    tmr2->start(5000); // Запускаем таймер
    //
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::paintEvent(QPaintEvent *event)
{
    int x,y;
    scene->clear();
    y = 0;
    while(y < rszy)
    {
        x = 0;
        while(x < rszx)
        {
            paint->setPen(QColor((dpix[x][y]),0,0));
            paint->drawPoint(x,y);
            x++;
        }
        y++;
    }
    //
    //info
    paint->setPen(QColor(255,255,255));
    switch(infmode)
    {
        case _caminfo:
            //позиция камеры
            paint->drawText(_pcamx,_pcamy,"CAM POSITION:");
            paint->drawText(_pcamx,_pcamy + _stepstr,"Horisontal \t" + QString::number(hcam));
            paint->drawText(_pcamx,_pcamy + _stepstr * 2,"Vertical \t" + QString::number(vcam));
            //
            paint->setPen(QPen(Qt::color0, 1, Qt::DashDotLine));
            paint->drawLine(_pghx + 50,_pghy + 50 - 55,_pghx + 50,_pghy + 50 + 55);
            paint->drawLine(_pghx + 50 - 55,_pghy + 50,_pghx + 50 + 55, _pghy + 50);
            paint->setPen(QPen(Qt::color0, 1, Qt::DotLine));
            paint->setBrush(QBrush(Qt::color0, Qt::NoBrush));
            paint->drawEllipse(_pghx,_pghy,100,100);
            paint->setPen(QPen(Qt::color0, 3, Qt::SolidLine));
            paint->setBrush(QBrush(Qt::color0, Qt::DiagCrossPattern));
            paint->drawPie(_pghx, _pghy, 100, 100, (67.5 + hcam) * 16, 45 * 16);
            //
            paint->setPen(QPen(Qt::color0, 1, Qt::DashDotLine));
            paint->drawLine(_pgvx + 50,_pgvy + 50 - 55,_pgvx + 50,_pgvy + 50 + 55);
            paint->drawLine(_pgvx + 50 - 55,_pgvy + 50,_pgvx + 50 + 55, _pgvy + 50);
            paint->setPen(QPen(Qt::color0, 1, Qt::DotLine));
            paint->setBrush(QBrush(Qt::color0, Qt::NoBrush));
            paint->drawEllipse(_pgvx,_pgvy,100,100);
            paint->setPen(QPen(Qt::color0, 3, Qt::SolidLine));
            paint->setBrush(QBrush(Qt::color0, Qt::DiagCrossPattern));
            paint->drawPie(_pgvx, _pgvy, 100, 100, (337.5 + vcam) * 16, 45 * 16);
            //
            break;
        case 2:
            //состояние приводов
            paint->drawText(_motorsx, _motorsy, "MOTORS:");
            paint->drawText(_motorsx, _motorsy + _stepstr, "M1 \t" + QString::number(valm1));
            paint->drawText(_motorsx, _motorsy + _stepstr * 2, "M2 \t" + QString::number(valm2));
            paint->drawText(_motorsx, _motorsy + _stepstr * 3, "M3 \t" + QString::number(valm3));
            paint->drawText(_motorsx, _motorsy + _stepstr * 4, "M4 \t" + QString::number(valm4));
            break;
        default:
            break;
    }
    switch(cmd)
    {
        case _cmd_stop:
            //paint->setPen(QColor(255,255,255));
            paint->drawText(_cmdx, _cmdy, "STOP");
            break;
        case _cmd_forward:
            //paint->setPen(QColor(255,255,255));
            paint->drawText(_cmdx, _cmdy, "FORWARD");
            break;
        case _cmd_backward:
            //paint->setPen(QColor(255,255,255));
            paint->drawText(_cmdx, _cmdy, "BACKWARD");
            break;
        case _cmd_left:
            //paint->setPen(QColor(255,255,255));
            paint->drawText(_cmdx, _cmdy, "LEFT");
            break;
        case _cmd_right:
            //paint->setPen(QColor(255,255,255));
            paint->drawText(_cmdx, _cmdy, "RIGHT");
            break;
        default:
            break;
    }
    scene->addPixmap(*pix);
}


void MainWindow::Vals(void)
{
    int val;
    //
    //
    //
    if((wCleintStatus() < 1) && (connected))
    {
        wDisconnect();
        connected = false;
    }
    //
    if((wVCleintStatus() < 1) && (vconnected))
    {
        wVDisconnect();
        vconnected = false;
    }
    if(!(vconnected))
    {
        ui->bvConnect->setText("Connect");
        ui->vstrIP->setEnabled(true);
        ui->vstrPort->setEnabled(true);
    }
    else
    {
        ui->bvConnect->setText("Disconnect");
        ui->vstrIP->setEnabled(false);
        ui->vstrPort->setEnabled(false);
        //
        wRdCam((unsigned char*)(&dpix[0][0]));
    }
    //
    if(!(connected))
    {
        ui->bConnect->setText("Connect");
        ui->b_stop->setEnabled(false);//test();
        ui->b_forward->setEnabled(false);
        ui->b_backward->setEnabled(false);
        ui->b_left->setEnabled(false);
        ui->b_right->setEnabled(false);
        ui->sl_speed->setEnabled(false);
        ui->strIP->setEnabled(true);
        ui->strPort->setEnabled(true);
        ui->pServNull->setEnabled((false));
        ui->hcam->setEnabled(false);
        ui->vcam->setEnabled(false);
    }
    else
    {
        ui->bConnect->setText("Disconnect");
        ui->b_stop->setEnabled(true);
        ui->b_forward->setEnabled(true);
        ui->b_backward->setEnabled(true);
        ui->b_left->setEnabled(true);
        ui->b_right->setEnabled(true);
        ui->sl_speed->setEnabled(true);
        ui->strIP->setEnabled(false);
        ui->strPort->setEnabled(false);
        ui->pServNull->setEnabled((true));
        ui->hcam->setEnabled(true);
        ui->vcam->setEnabled(true);
    }
    //
    switch(cmd)
    {
        case _cmd_forward:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val;
            wrvalm3 = val;
            wrvalm4 = val;
            break;
        case _cmd_backward:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val * (-1);
            wrvalm3 = val * (-1);
            wrvalm4 = val * (-1);
            break;
        case _cmd_left:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val;
            wrvalm3 = val * (-1);
            wrvalm4 = val;
            break;
        case _cmd_right:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val * (-1);
            wrvalm3 = val;
            wrvalm4 = val * (-1);
            break;
        default:
            wrvalm1 = 0;
            wrvalm2 = 0;
            wrvalm3 = 0;
            wrvalm4 = 0;
            cmd = _cmd_stop;
            break;
    }
    //
    valm1   = wRdReg(_num_vol_m1);
    valm2   = wRdReg(_num_vol_m2);
    valm3   = wRdReg(_num_vol_m3);
    valm4   = wRdReg(_num_vol_m4);
    hcam    = wRdReg(_num_pos_s1);
    vcam    = wRdReg(_num_pos_s2);
    //
    wWrReg(_num_vol_m1, wrvalm1);
    wWrReg(_num_vol_m2, wrvalm2);
    wWrReg(_num_vol_m3, wrvalm3);
    wWrReg(_num_vol_m4, wrvalm4);
    //
    wrhcam = (ui->hcam->value()) * (-1);
    wrvcam = ui->vcam->value();
    //
    wWrReg(_num_pos_s1, wrhcam);
    wWrReg(_num_pos_s2, wrvcam);
    //
    ui->ltmark->setText(QString::number(rtmark));
    //
    if((hcam != hcamold) || (vcam != vcamold))
        infmode = _caminfo;
}

void MainWindow::on_b_forward_clicked()
{
    cmd = _cmd_forward;
}

void MainWindow::on_b_stop_clicked()
{
    cmd = _cmd_stop;
}

void MainWindow::on_b_backward_clicked()
{
    cmd = _cmd_backward;
}

void MainWindow::on_b_left_clicked()
{
    cmd = _cmd_left;
}

void MainWindow::on_b_right_clicked()
{
    cmd = _cmd_right;
}

//связь с сервером управления
void MainWindow::on_bConnect_clicked()
{
    QString qstrip      = ui->strIP->text();
    QString qstrport    = ui->strPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(connected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wConnect(&strip[0], port);
        if(res == 0)
            connected = true;
    }
    else
    {
        wDisconnect();
        connected = false;
    }
}

void MainWindow::on_pServNull_clicked()
{
    ui->hcam->setValue(0);
    ui->vcam->setValue(0);
}

void MainWindow::on_bvConnect_clicked()
{
    QString qstrip      = ui->vstrIP->text();
    QString qstrport    = ui->vstrPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(vconnected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wVConnect(&strip[0], port);
        if(res == 0)
            vconnected = true;
    }
    else
    {
        wVDisconnect();
        vconnected = false;
    }
}

void MainWindow::TimerInfo(void)
{
    //
    if((hcam != hcamold) || (vcam != vcamold))
    {
        hcamold = hcam;
        vcamold = vcam;
        infmode = _caminfo;
        return;
    }
    //
    if(infmode < _inf_max)
        infmode++;
    else
        infmode = 0;
}
