#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui/QPaintEvent>
#include <QTimer>
#include <qgraphicsview.h>
#include <QPainter>
//#include "types.h"

#define _def_ip         "192.168.7.1"

#define _cmd_stop       0
#define _cmd_forward    1
#define _cmd_backward   2
#define _cmd_left       3
#define _cmd_right      4
//
#define _inf_max        2
//
#define _stepstr        15
//
#define _caminfo        1
#define _pcamx          30
#define _pcamy          30
#define _pghx           30
#define _pghy           100
#define _pgvx           30
#define _pgvy           250
//
#define _motorsx        30
#define _motorsy        30
//
#define _cmdx           30
#define _cmdy           450


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    int     valm1;
    int     valm2;
    int     valm3;
    int     valm4;
    int     wrvalm1;
    int     wrvalm2;
    int     wrvalm3;
    int     wrvalm4;
    int     wrhcam;
    int     wrvcam;
    int     hcam;
    int     vcam;
    int     hcamold;
    int     vcamold;
    int     cmd;
    bool    connected;
    bool    vconnected;
    //
    int     widht;
    int     height;
    int     swidht;
    int     sheight;
    uchar   dpix[640][480];
    int     infmode;
    int     infcnt;

private slots:
    void on_b_forward_clicked();

    void on_b_stop_clicked();

    void on_b_backward_clicked();

    void on_b_left_clicked();

    void on_b_right_clicked();

    //void fdraw(void);
    void paintEvent(QPaintEvent *event);

    void Vals(void);

    void TimerInfo(void);

    void on_bConnect_clicked();

    void on_pServNull_clicked();

    void on_bvConnect_clicked();

private:
    //void Vals(void);
    QTimer *tmr;
    QTimer *tmr2;
    Ui::MainWindow  *ui;
    QGraphicsScene  *scene;
    QGraphicsView   *gView;
    QPixmap         *pix;
    QPainter        *paint;

};

#endif // MAINWINDOW_H
